__author__='sigilis.com'
__version__='0.2'
from pandac.PandaModules import BitMask32,Filename

from SigilisModel import SigilisModel

import urllib
import threading

class Generic(SigilisModel):
	def __init__(self,data,user=None):
		SigilisModel.__init__(self,user=user,data=data,modeltype='Generic')
		if self.good==True:	
			self.model=data['model']
			self.textures=data['textures']
			self.heading=float(data['heading'])
			self.scaleX=float(data['scaleX'])
			self.scaleY=float(data['scaleY'])
			self.scaleZ=float(data['scaleZ'])
			self.pitch=float(data['pitch'])
			self.roll=float(data['roll'])
			self.textureThread=threading.Thread(	name='GetTextures'+self.sigmod+'-'+str(self.x)+'-'+str(self.y)+'-'+str(self.z),
							target=self.getTexturesThread)
			self.textureThread.start()	
			self.modelThread=threading.Thread(	name='GetModel'+self.sigmod+'-'+str(self.x)+'-'+str(self.y)+'-'+str(self.z),
							target=self.checkRemModel)
			self.modelThread.start()				
			self.textureThread.join()
			self.modelThread.join()
			self.buildThread=threading.Thread(	name='Build'+self.sigmod+'-'+str(self.x)+'-'+str(self.y)+'-'+str(self.z),
							target=self.loadModThread)
			self.buildThread.start()			
		else:
			del(self)
			
	def getTexturesThread(self):
		for tex in self.textures:
			self.checkRemTexture(tex)
				
			
	def checkRemTexture(self,remfile):
		exists=False
		localfile='generics/'+remfile.replace('://','.').replace('/','.')
		lfile=Filename.binaryFilename(localfile)
		if not lfile.exists():
			(loadfilename,loadheaders)=urllib.urlretrieve(remfile,localfile)
			#getText=threading.Thread(	name='GetRemTex'+self.sigmod+'-'+str(self.x)+'-'+str(self.y)+'-'+str(self.z),
			#				target=self.getRemTexture,kwargs={'remfile':remfile,'localfile':localfile})
			#getText.start()
			
	def getRemTexture(self,remfile,localfile):
		(loadfilename,loadheaders)=urllib.urlretrieve(remfile,localfile)
		
	def checkRemModel(self):
		localfile='generics/'+self.model.replace('://','.').replace('/','.')
		lfile=Filename.binaryFilename(localfile)
		if not lfile.exists():
			(loadfilename,loadheaders)=urllib.urlretrieve(self.model,localfile)
		self.model=localfile
					
	def getRemModel(self,remfile,localfile):
		(loadfilename,loadheaders)=urllib.urlretrieve(remfile,localfile)
		self.model=localfile
						
	def loadModThread(self):
		Model=self.nPath
		Model=loader.loadModel(self.model)	
		Model.node().setIntoCollideMask(BitMask32.bit(19))
		Model.node().setIntoCollideMask(BitMask32.bit(20))
		Model.reparentTo(render.find('Objects/Generics'))                     
		Model.setPos(self.x,self.y,self.z)
		Model.setScale(self.scaleX,self.scaleY,self.scaleZ)
		Model.setH(self.heading)		
		Model.setP(self.pitch)
		Model.setR(self.roll)
		
	def getVarSpec(self):
		return {'x':['float',0,'text','X position'],'y':['float',0,'text','Y position'],'z':['float',0,'text','Z position'],
			'heading':['float',1,'text','Heading (0-360)'],
			'model':['str',2,'text/file','Model URL|or, Upload File'],
			'textures':['str',2,'text/file','Comma separated texture URL(s)|or, Upload File'],
			'texture2':['str',2,'file','Extra Texture File'],
			'texture3':['str',2,'file','Extra Texture File'],
			'texture4':['str',2,'file','Extra Texture File'],
			'texture5':['str',2,'file','Extra Texture File'],
			'texture6':['str',2,'file','Extra Texture File'],
			'texture7':['str',2,'file','Extra Texture File'],
			'texture8':['str',2,'file','Extra Texture File'],
			'scaleX':['float',1,'text','X Scale'],'scaleY':['float',1,'text','Y Scale'],
			'scaleZ':['float',1,'text','Z Scale'],
			'pitch':['float',1,'text','Pitch (0-360)'],'roll':['float',1,'text','Roll (0-360)'],
			'reqtosubmit':['str',0,'hidden','x,y,z,model,textures'],
			'defaults':['str',0,'hidden','heading=0,scaleX=1,scaleY=1,scaleZ=1,pitch=0,roll=0']}		
