__author__='sigilis.com'
__version__='0.2'
from pandac.PandaModules import BitMask32

from SigilisModel import SigilisModel
from direct.gui.DirectGui import DirectFrame,DirectEntry,DirectLabel,DirectButton,DirectCheckButton

DEFAULTTILE='textures/floors/checkerboard.png'

class RoadSign(SigilisModel):
	def __init__(self,data,user=None):
		SigilisModel.__init__(self,user=user,data=data,modeltype='RoadSign')
		if self.good==True:
			self.heading=float(data['heading'])
			sgn=loader.loadModel('models/sign')	
			sgn.node().setIntoCollideMask(BitMask32.bit(19))
			self.sign1=data['sign1'].split(',')
			self.sign2=data['sign2'].split(',')
			self.sign1_remote=int(data['sign1_remote'])
			self.sign2_remote=int(data['sign2_remote'])
			sign1a = loader.loadTexture(self.sign1[0])
			sign1b = loader.loadTexture(self.sign1[1])
			sign2a = loader.loadTexture(self.sign2[0])
			sign2b = loader.loadTexture(self.sign2[1])
			sgn.find('**/Sign1a').setTexture(sign1a, 1)
			sgn.find('**/Sign1b').setTexture(sign1b, 1)
			sgn.find('**/Sign2a').setTexture(sign2a, 1)
			sgn.find('**/Sign2b').setTexture(sign2b, 1)
			#sgn.ls()
			sgn.reparentTo(self.nPath)
			self.nPath.reparentTo(render.find('Objects/RoadSigns'))           
			self.nPath.setPos(self.x,self.y,self.z) 
			self.nPath.setH(self.heading)
#			sqText=loader.loadTexture(self.tile)
#			sq.setTexture(sqText)
#			sgn.setTwoSided(True)
		else:
			del(self)
	
	def Screen(self,mode):
		self.user.avatar.accepting=False
		if self.user.widescreen=='yes':
			xpos=-1.2
		else:
			xpos=-1.0
		self.editFrame = DirectFrame(frameSize = (-.3,.32,-.7,.5), frameColor=(.3,.2,.1,1),
						pos = (xpos,0, .5)) 
		self.editFrame.reparentTo(aspect2d)
		x = DirectLabel(parent=self.editFrame,text='X Pos:',
				      pos=(-.2,0,.35), scale = .04)
		y = DirectLabel(parent=self.editFrame,text='Y Pos:',
				      pos=(-.2,0,.25), scale = .04)
		z = DirectLabel(parent=self.editFrame,text='Z Pos:',
				      pos=(-.2,0,.15), scale = .04)
		head = DirectLabel(parent=self.editFrame,text='X Pos:',
				      pos=(-.2,0,.05), scale = .04)
		sign1a = DirectLabel(parent=self.editFrame,text='Sign 1a:',
				      pos=(-.2,0,-.05), scale = .04)
		sign1b = DirectLabel(parent=self.editFrame,text='Sign 1b:',
				      pos=(-.2,0,-.15), scale = .04)
		sign1_rem = DirectLabel(parent=self.editFrame,text='Sign 1 remote:',
				      pos=(-.2,0,-.25), scale = .04)		      
		sign2a = DirectLabel(parent=self.editFrame,text='Sign 2a:',
				      pos=(-.2,0,-.35), scale = .04)
		sign2b = DirectLabel(parent=self.editFrame,text='Sign 2b:',
				      pos=(-.2,0,-.45), scale = .04)
		sign2_rem = DirectLabel(parent=self.editFrame,text='Sign 2 remote:',
				      pos=(-.2,0,-.55), scale = .04)
				      
		if mode=='edit':
			info = DirectLabel(parent=self.editFrame,text=self.nodeName,
						  pos=(0,0,.45), scale = .05)
			self.xEntry = DirectEntry(parent=self.editFrame,initialText=str(self.nPath.getX()),
						  pos=(-.11,0,.35), scale = .04)
			self.yEntry = DirectEntry(parent=self.editFrame,initialText=str(self.nPath.getY()),
						  pos=(-.11,0,.25), scale = .04)
			self.zEntry = DirectEntry(parent=self.editFrame,initialText=str(self.nPath.getZ()),
						  pos=(-.11,0,.15), scale = .04)
			self.headEntry = DirectEntry(parent=self.editFrame,initialText=str(self.nPath.getH()),
						  pos=(-.11,0,.05), scale = .04)
			self.sgn1Entry1 = DirectEntry(parent=self.editFrame,initialText=str(self.sign1[0]),
						  pos=(-.11,0,-.05), scale = .04)
			self.sgn1Entry2 = DirectEntry(parent=self.editFrame,initialText=str(self.sign1[1]),
						  pos=(-.11,0,-.15), scale = .04)
			self.sgn1rem = DirectCheckButton(parent=self.editFrame,indicatorValue=self.sign1_remote,
						  pos=(.1,0,-.25), scale = .04)
			self.sgn2Entry1 = DirectEntry(parent=self.editFrame,initialText=str(self.sign2[0]),
						  pos=(-.11,0,-.35), scale = .04)
			self.sgn2Entry2 = DirectEntry(parent=self.editFrame,initialText=str(self.sign2[1]),
						  pos=(-.11,0,-.45), scale = .04)
			self.sgn2rem = DirectCheckButton(parent=self.editFrame,indicatorValue=self.sign2_remote,
						  pos=(.1,0,-.55), scale = .04)
						  
		if mode=='create':
			info = DirectLabel(parent=self.editFrame,text='New Roadsign',
						  pos=(0,0,.45), scale = .05)
			self.xEntry = DirectEntry(parent=self.editFrame,initialText='',
						  pos=(-.11,0,.35), scale = .04)
			self.yEntry = DirectEntry(parent=self.editFrame,initialText='',
						  pos=(-.11,0,.25), scale = .04)
			self.zEntry = DirectEntry(parent=self.editFrame,initialText='',
						  pos=(-.11,0,.15), scale = .04)
			self.headEntry = DirectEntry(parent=self.editFrame,initialText='',
						  pos=(-.11,0,.05), scale = .04)
			self.sgn1Entry1 = DirectEntry(parent=self.editFrame,initialText='',
						  pos=(-.11,0,-.05), scale = .04)
			self.sgn1Entry2 = DirectEntry(parent=self.editFrame,initialText='',
						  pos=(-.11,0,-.15), scale = .04)
			self.sgn1rem = DirectCheckButton(parent=self.editFrame,indicatorValue=0,
						  pos=(.1,0,-.25), scale = .04)
			self.sgn2Entry1 = DirectEntry(parent=self.editFrame,initialText='',
						  pos=(-.11,0,-.25), scale = .04)
			self.sgn2Entry2 = DirectEntry(parent=self.editFrame,initialText='',
						  pos=(-.11,0,-.35), scale = .04)
			self.sgn2rem = DirectCheckButton(parent=self.editFrame,indicatorValue=0,
						  pos=(.1,0,-.55), scale = .04)
						  
		if (self.owner==self.user.username):	      
			setButton = DirectButton(parent=self.editFrame,text='Set',
						  pos=(-.15,0,-.62), scale = .04)
			updateButton = DirectButton(parent=self.editFrame,text='Show New',
						  pos=(.15,0,-.62), scale = .04,command=self.updatePos)
		else:
			owner = DirectLabel(parent=self.editFrame,text='Owner: '+self.owner,
				      pos=(-.2,0,-.62), scale = .04)	
		exitButton = DirectButton(parent=self.editFrame,text='EXIT',
					  pos=(0,0,-.67), scale = .04,command=self.exitEdit)			 
					  	
	def getVarSpec(self):
		return {'x':['float',0,'text','X position'],'y':['float',0,'text','Y position'],'z':['float',0,'text','Z position'],
			'heading':['float',1,'text','Heading'],
			'sign1a':['str',3,'text/file','Sign 1 front local relative path or URL|or, Upload File'],
			'sign1a_remote':['bool',4,'radio','Is texture remote?'],
			'sign1b':['str',3,'text/file','Sign 1 back local relative path or URL|or, Upload File'],
			'sign1b_remote':['bool',4,'radio','Is texture remote?'],
			'sign2a':['str',3,'text/file','Sign 2 front local relative path or URL|or, Upload File'],
			'sign2a_remote':['bool',4,'radio','Is texture remote?'],
			'sign2b':['str',3,'text/file','Sign 2 back local relative path or URL|or, Upload File'],
			'sign2b_remote':['bool',4,'radio','Is texture remote?'],
			'reqtosubmit':['str',0,'hidden','x,y,z,sign1a,sign1b,sign2a,sign2b'],
			'defaults':['str',0,'hidden','heading=0']}
			
