__author__='sigilis.com'
__version__='0.2'
from pandac.PandaModules import Filename,Texture,NodePath,TextNode
from direct.gui.DirectGui import DirectFrame,DirectEntry,DirectLabel,DirectButton
from direct.gui.OnscreenText import OnscreenText
from direct.showbase.DirectObject import DirectObject

import urllib
import threading


class SigilisModel(DirectObject):
	def __init__(self,user,data=None,modeltype=None,DEFAULTU=None,DEFAULTV=None):
		self.good=True
		if data!=None:
			self.data=data
			self.x=float(data['x'])
			self.y=float(data['y'])
			self.z=float(data['z'])
			self.user=user
			self.owner=data['owner']
			print 'USER',self.user
			self.sigmod=modeltype
			self.nodeName=modeltype+":"+str(self.x)+'-'+str(self.y)+'-'+str(self.z)
			if render.find('Objects/'+modeltype+'s').isEmpty():
				Group=NodePath(modeltype+'s')
				Group.reparentTo(render.find('Objects'))
				Group.setPos(0,0,0)
			if render.find('Objects/'+modeltype+'s/'+self.nodeName).isEmpty():
				self.nPath=NodePath(self.nodeName)	
				self.nPath.setShaderAuto()
				if data.has_key('tile'):
				    self.tile=data['tile']
				    self.tile_remote=int(data['tile_remote'])	
				if data.has_key('tile_scale'):
				    self.tile_scale=float(data['tile_scale'])
				if data.has_key('width'):
				    self.width=float(data['width'])
				if data.has_key('length'):
				    self.length=float(data['length'])
				if data.has_key('height'):
				    self.height=float(data['height'])
				if data.has_key('tile_rot'):
				    self.tile_rot=float(data['tile_rot'])
				else:
				    self.tile_rot=0
				    
				if data.has_key('wrapU'):
				    self.wrapU=eval(data['wrapU'])
				    self.wrapV=eval(data['wrapV'])
				else:	
				    if DEFAULTU != None:
					self.wrapU=DEFAULTU
					self.wrapV=DEFAULTV
				print 'sigmod',self,'x',self.x
				
		
				self.accept("mouse1", self.mouseLeft)
				#self.accept("mouse1-up", self.setKey, ["moused1",0])
				self.accept("mouse2", self.mouseCenter)
				#self.accept("mouse2-up", self.setKey, ["moused2",0])
				self.accept("mouse3", self.mouseRight)
				#self.accept("mouse3-up", self.setKey, ["moused3",0])
				
			else:
				self.good=False
		else:
			self.good=False

		
	def checkRemoteTexture(self,nPATH,localPATH,remfile,fallback,wrapU,wrapV):
		localfile=localPATH+remfile.replace('://','.').replace('/','.')
		lfile=Filename.binaryFilename(localfile)
		if lfile.exists():
			thisTexture=loader.loadTexture(localfile)
			exists=True
		else:
			thisTexture=loader.loadTexture(fallback)
			exists=False
		thisTexture.setWrapU(Texture.WMRepeat)
		thisTexture.setWrapV(Texture.WMRepeat)
		#self.floor.setTexGen( TextureStage.getDefault( ), TexGenAttrib.MWorldPosition )
		#self.floor.setTexScale( TextureStage.getDefault( ), self.tile_scale, self.tile_scale )
		nPATH.setTexture(thisTexture)		
		if exists==False:
			getText=threading.Thread(	name='GetTexture-'+self.sigmod+'-'+str(self.x)+'-'+str(self.y)+'-'+str(self.z),
							target=self.getRemoteTexture,kwargs={'nPATH':nPATH,'remfile':remfile,'localfile':localfile})
			getText.start()
				
	def getRemoteTexture(self,nPATH,remfile,localfile):
		(loadfilename,loadheaders)=urllib.urlretrieve(remfile,localfile)	
		nPATH.setTexture(loader.loadTexture(loadfilename),1)		
			
			
	def createModelFrame(self,modelType,pos):
		exec('from modelclasses.'+modelType+' import '+modelType)
		modelvars=eval(modelType+'.getVarSpec('+modelType+'())')
		modvars=[]
		self.modelFrame = DirectFrame(frameSize = (-.5,.5,-.5,.5), frameColor=(.3,.2,.1,1)) 
		for i in range(len(modelvars)):
			modvars.append([])
		for k,v in modelvars.iteritems():
				modvars[v[1]].append([k,v[0],v[2]])
				modvars[v[1]].sort()
		for varRow in modvars:
			if varRow!=None:
				for var in varRow:
					print 'vars',var
					execStr='self.'+var[2]+"('"+var[0]+"','"+var[1]+"')"
					print execStr
					exec(execStr)
					
	def textBox(self,var,vtype):
		if (vtype=='text'):
			print 'textbox'
			
	def mouseLeft(self):
		if self.user != None:
			picked=self.mouseSort()
			if picked==True:
				print 'moused left on', self
		
	def mouseCenter(self):
		if self.user != None:
			picked=self.mouseSort()
			if picked==True:
				print 'moused center on', self
		
	def mouseRight(self):
		if self.user != None:
			picked=self.mouseSort()
			if picked==True:
				self.Screen('edit')	 		
				
	def mouseSort(self):
		mpos=base.mouseWatcherNode.getMouse()
		self.user.avatar.pickerRay.setFromLens(self.user.avatar.myCAMNode, mpos.getX(), mpos.getY())
		entries=self.user.avatar.mouseHandler.getNumEntries()
		picked=False
		if entries > 0:
			self.user.avatar.mouseHandler.sortEntries() #this is so we get the closest object
			#print 'num of entries',entries
			#for i in range(entries):
			#	print 'entry',i,self.user.avatar.mouseHandler.getEntry(0)
			pickedEntry=self.user.avatar.mouseHandler.getEntry(0)
			pickedColl=pickedEntry.getInto()
			pickedNP=pickedEntry.getIntoNodePath()
			if not self.nPath.find('**/'+pickedNP.getName()).isEmpty() :
				#print 'picked', pickedNP.getName(), self.nPath.getName()
				self.user.avatar.mouseHandler.clearEntries()
				picked=True
		return picked

 

	def updatePos(self):
		print 'NEW POS',self.xEntry.onscreenText.getText(),self.yEntry.onscreenText.getText(),self.zEntry.onscreenText.getText()
		print 'NEW POS',self.xEntry.get(),self.yEntry.get(),self.zEntry.get()
		print 'CURRENT POS',self.nPath.getPos()
		self.nPath.setPos(float(self.xEntry.get()),float(self.yEntry.get()),float(self.zEntry.get()))
		print 'NEW POS',self.nPath.getPos()

	def setText(self,val,entry):
		exec(entry+".setText('"+str(val)+"')")

	def exitEdit(self):
		self.user.avatar.accepting=True
		self.editFrame.destroy()
