__author__='sigilis.com'
__version__='0.2'
from pandac.PandaModules import BitMask32

from SigilisModel import SigilisModel

DEFAULTTILE='textures/floors/checkerboard.png'

class Square(SigilisModel):
	def __init__(self,data,user=None):
		SigilisModel.__init__(self,user=user,data=data,modeltype='Square')
		if self.good==True:
			self.size=float(data['size'])
			self.heading=float(data['heading'])
			self.pitch=float(data['pitch'])
			self.roll=float(data['roll'])
			sq=loader.loadModel('models/square')	
			sq.node().setIntoCollideMask(BitMask32.bit(20))
			sq.setScale(self.size)
			sq.reparentTo(render)           
			sq.setPos(self.x,self.y,self.z) 
			sq.setHpr(self.heading,self.pitch,self.roll)
			sqText=loader.loadTexture(self.tile)
			sq.setTexture(sqText)
			sq.setTwoSided(True)
		else:
			del(self)
		
	def getVarSpec(self):
		return {'x':['float',0,'text','X position'],'y':['float',0,'text','Y position'],'z':['float',0,'text','Z position'],
			'size':['float',2,'text','Square size'],'heading':['float',1,'text','Heading'],
			'pitch':['float',1,'text','Pitch'],'roll':['float',2,'text','Roll'],
			'tile':['str',3,'text/file','Texture local relative path or URL|or, Upload File'],
			'tile_remote':['bool',4,'radio','Is texture remote?'],'tile_scale':['float',5,'text','Tile Scale Factor'],
			'reqtosubmit':['str',0,'hidden','x,y,z,width,size,tile'],
			'defaults':['str',0,'hidden','heading=0,pitch=0,roll=0,tile_scale=1']}
			
